package org.andorp.testkeys;

import java.util.HashMap;

import org.andorp.testkeys.context.ContextException;
import org.andorp.testkeys.context.Value;
import org.andorp.testkeys.context.Variable;

public final class Context {
    
    private final HashMap<Variable, Value<?>> bindings;
	private final Context parent;
    
    public Context() {
        bindings = new HashMap<Variable, Value<?>>();
        parent = null;
    }
    
    private Context(Context _parent) {
        bindings = new HashMap<Variable, Value<?>>();
        parent = _parent;
    }
    
    public Context newFrame() {
        return new Context(this);
    }
    
    public void bind(Variable v, Value<?> x) {
        bindings.put(v, x);
    }
    
    
    public Value<?> get(Variable v) throws ContextException {
        Value<?> x = bindings.get(v);
        if(x == null) {
            if(parent != null) {
                return get(v);
            }
            throw new ContextException("Variable not found in context");
        }
        return x;
    }
    
    public static Context EmptyContext() {
        return new Context();
    }
}
