package org.andorp.testkeys;

public final class KeywordName {
    
    private final String name;
    
    public KeywordName(String _name) {
        assert _name != null;
        assert !(_name.isEmpty());
        name = _name;
    }
    
    public String name() {
    	return name;
    }
    
    @Override
    public String toString() {
        return name;
    }
    
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((name == null) ? 0 : name.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        KeywordName other = (KeywordName) obj;
        if (name == null) {
            if (other.name != null)
                return false;
        } else if (!name.equals(other.name))
            return false;
        return true;
    }
    
}
