package org.andorp.testkeys;

import org.andorp.testkeys.KeywordException;
import org.andorp.testkeys.RollbackException;

public final class KeywordRepr {
    
    /* Keyword step common representation */
    
    private final KeywordStep     step;
    private final KeywordRollback rollback;
    private final KeywordName     name;
    
    public KeywordRepr(
             KeywordName _name,
             KeywordStep _step,
             KeywordRollback _rollback
             ) {
        assert _name != null;
        assert _step != null;
        assert _rollback != null;
        
        name = _name;
        step = _step;
        rollback = _rollback;
    }
    
    public KeywordName name() {
        return name;
    }
    
    public boolean step(final Context c) throws KeywordException {
        try {
            return step.runStep(c);
        } catch (KeywordException e) {
            throw e;
        } catch (Exception e) {
            throw new KeywordException(e);
        }
    }
    
    public void rollback() throws RollbackException {
        try {
            rollback.runRollback();
        } catch (RollbackException e) {
            throw e;
        } catch (Exception e) {
            throw new RollbackException(e);
        }
    }
    
    KeywordRollback getKeywordRollback() {
        return rollback;
    }
    
}
