package org.andorp.testkeys;

import org.andorp.testkeys.annotation.AnnotedKeywordFactory;
import org.andorp.testkeys.annotation.Name;
import org.andorp.testkeys.annotation.Rollback;
import org.andorp.testkeys.annotation.Step;

public class Main {
    
    public static void main(String[] args) throws Exception {
        
    	final AnnotedKeywordFactory af = new AnnotedKeywordFactory();
    	final AnnotationKWTes test = new AnnotationKWTes();
    	
    	KeywordRepr kw = af.createKeyword(test);
    	System.out.println(kw.name().name());
    	kw.step(null);
    	kw.rollback();
    }

    @Name(name="hello")
    public static class AnnotationKWTes {
    	
    	@Step
    	public boolean step(final Context c) {
    		System.out.println("Hello: step");
    		return false;
    	}
    	
    	@Rollback
    	public void rollback() {
    		System.out.println("Hello: rollback");
    	}
    }
}

