package org.andorp.testkeys.annotation;

import java.lang.reflect.Method;

import org.andorp.testkeys.KeywordRollback;

public final class AKeywordRollback implements KeywordRollback {

    private final Object object;
    private final Method method;
    
    public AKeywordRollback(Object _object, Method _method) {
        assert _object != null;
        assert _method != null;
        
        object = _object;
        method = _method;
    }
    
    public void runRollback() {
        // TODO More elegant exceptions
        try {
            method.invoke(object, new Object[0]);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

}
