package org.andorp.testkeys.annotation;

import java.lang.reflect.Method;

import org.andorp.testkeys.Context;
import org.andorp.testkeys.KeywordException;
import org.andorp.testkeys.KeywordStep;

public class AKeywordStep implements KeywordStep {

    private final Object object;
    private final Method method;
    
    public AKeywordStep(Object _object, Method _method) {
        if(_method == null) {
            System.out.println("Method is null");
        }
        
        object = _object;
        method = _method;
    }

    public boolean runStep(final Context c) throws KeywordException {
        // TODO More elegant exceptions
        try {
            final Object[] args = new Object[] { c };
            Boolean r = (Boolean)(method.invoke(object, args));
            return r;
        } catch (Exception e) {
            throw new KeywordException(e);
        }
    }

}
