package org.andorp.testkeys.context;

public abstract class Value<T> {
    
    private Value() {
    }
    
    public abstract T getValue();
    
    public static Value<Integer> INT(int x) {
        return new Int(x);
    }
    
    public static Value<String> STR(String str) {
        return null;
    }
    
    public static class Int extends Value<Integer> {
        
        private final int x;
        
        private Int(int _x) {
           x = _x;
        }
        
        public Integer getValue() {
            return x;
        }
    }
    
    public static class Str extends Value<String> {
        private final String s;
        
        private Str(String _s) {
            s = _s;
        }
        
        public String getValue() {
            return s;
        }
    }
}
