package org.andorp.testkeys.interfaced;

import org.andorp.testkeys.Context;
import org.andorp.testkeys.Keyword;
import org.andorp.testkeys.KeywordException;
import org.andorp.testkeys.KeywordName;
import org.andorp.testkeys.KeywordRollback;
import org.andorp.testkeys.KeywordStep;
import org.andorp.testkeys.RollbackException;

public final class KeywordObject implements KeywordStep, KeywordRollback {

    private final Keyword value;
    
    public KeywordObject(Keyword _value) {
        value = _value;
    }

    public boolean runStep(final Context c) throws KeywordException {
        return value.step(c);
    }

    public void runRollback() throws RollbackException {
        value.rollback();
    }

    public KeywordName name() {
        return value.name();
    }

}
