package org.andorp.testkeys.interfaced;

import org.andorp.testkeys.KeywordRepr;
import org.andorp.testkeys.KeywordCreationException;
import org.andorp.testkeys.KeywordFactory;
import org.andorp.testkeys.Keyword;

public class KeywordObjectFactory<T extends Keyword> 
  implements KeywordFactory<T> {
    
    public KeywordRepr createKeyword(T value) throws KeywordCreationException {
        if(value == null) {
            throw new KeywordCreationException(new IllegalArgumentException(
               "Given object was null"
            ));
        }
        
        final KeywordObject keywordObject = new KeywordObject(value);
        
        return new KeywordRepr(
            keywordObject.name(),
            keywordObject,
            keywordObject
        );
    }

}
