package org.andorp.testkeys.story;

import java.util.ArrayList;
import java.util.List;

import org.andorp.testkeys.KeywordName;

public final class Story {

    private KeywordName name;
    private final List<KeywordName> steps;
    
    public Story() {
        steps = new ArrayList<KeywordName>();
    }
    
    public void addStep(KeywordName name) {
        steps.add(name);
    }
    
    public boolean isEmpty() {
        return steps.isEmpty();
    }
    
    public void setName(KeywordName _name) {
        name = _name;
    }
    
    public KeywordName name() {
        return name;
    }
    
    public boolean isValidStory() {
        return name != null && steps.size() > 0;
    }
    
    public List<KeywordName> steps() {
        final ArrayList<KeywordName> _steps = new ArrayList<KeywordName>();
        for(KeywordName k : steps) {
            _steps.add(k);
        }
        return _steps;
    }

}
