package org.andorp.testkeys.story;

import java.util.ArrayList;

import org.andorp.testkeys.KeywordName;

public final class StringStoryBuilder {

	final ArrayList<KeywordName> steps;
	
	public StringStoryBuilder() {
		steps = new ArrayList<KeywordName>();
	}

	public void add(String n) {
		steps.add(new KeywordName(n));
	}
	
	public Story build(String name) {
		final Story s = new Story();
		for(KeywordName n : steps) {
			s.addStep(n);
		}
		s.setName(new KeywordName(name));
		steps.clear();
		return s;
	}
	
}
