package org.andorp.testkeys.test;

import org.andorp.testkeys.Context;
import org.andorp.testkeys.KeywordRepr;
import org.andorp.testkeys.KeywordException;
import org.andorp.testkeys.RollbackException;

public final class Runner {
    
    public Result run(final Context c, final KeywordRepr keyword) throws RollbackException {
        try {
            final boolean result = keyword.step(c);
            if (result) {
                return Result.PASSED;
            }
            keyword.rollback();
            return Result.FAILED;
        } catch (KeywordException ke) {
            keyword.rollback();
            return Result.FAILED;
        }
    }
    
}
