package org.andorp.testkeys.stage1;

import java.io.ByteArrayInputStream;
import java.io.UnsupportedEncodingException;
import java.util.List;

import org.andorp.testkeys.KeywordName;
import org.andorp.testkeys.story.ParserException;
import org.andorp.testkeys.story.Story;
import org.andorp.testkeys.story.xml.XMLParser;
import org.testng.Assert;
import org.testng.annotations.Test;

public class TestXMLStoryParser {
    
    @Test()
    public void testXMLParser() throws UnsupportedEncodingException, ParserException {
        XMLParser parser = new XMLParser();
        String xml = testXML();
        Story result = parser.parse(new ByteArrayInputStream(xml.getBytes("UTF-8")));
        Assert.assertNotNull(result, "The parser returned null as story object");
        Assert.assertEquals(result.name().name(), "story");
        final List<KeywordName> steps = result.steps();
        Assert.assertEquals(steps.size(), 1);
        Assert.assertEquals(steps.get(0).name(), "Good step");
    }
    
    private String testXML() {
       return
          "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\r\n" +
          "<story name=\"story\">\r\n" +
          "  <step>Good step</step>\r\n" +
          "</story>\r\n" +
          "";
    }
    
}
